<template>
  <div class="sign-up">
    <div class="max-w-xl mx-auto mt-2 md:mt-8 lg:mt-16">
      <div class="bg-white p-8 shadow rounded-lg">
        <h1 class="text-3xl text-center font-semibold tracking-wind uppercase">
          Sign Up
        </h1>
        <error-alert :errors="errors" v-if="showError" :show="showError"></error-alert>
        <form action="#" class="mt-5" @submit.prevent="submitSignUp">
          <div class="form-group mb-5">
            <input type="text" name="name" class="rounded w-full shadow p-2 border border-gray-900 tracking-wide text-lg" placeholder="Name" id="sign-up-name" autofocus autocomplete="on" v-model="signUpParams.name">
          </div>

          <div class="form-group mb-5">
            <input type="email" name="email" class="rounded w-full shadow p-2 border border-gray-900 tracking-wide text-lg" placeholder="Email" id="sign-up-email" autocomplete="on"  v-model="signUpParams.email">
          </div>

          <div class="form-group mb-5">
            <input type="password" name="email" class="rounded w-full shadow p-2 border border-gray-900 tracking-wide text-lg" placeholder="Password" id="sign-up-password" autocomplete="off"  v-model="signUpParams.password">
          </div>

          <div class="text-center flex justify-between">
            <router-link :to="{ name: 'SignIn'}" class="self-center hover:underline hover:text-gray-800">Sign In</router-link>
            <button type="submit" class="px-4 py-2 rounded tracking-wide font-semibold bg-black text-white text-lg hover:bg-gray-800 shadow-lg">Sign Up</button>
          </div>
        </form>
      </div>
    </div>
  </div>
</template>

<script>
  import axios from "axios"
  import ErrorAlert from "@/components/ErrorAlert.vue"

  export default {
    name: "SignUp",
    components: {
      ErrorAlert
    },
    data() {
      return {
        signUpParams: {},
        errors: [],
        showError: false
      }
    },
    methods: {
      async submitSignUp() {
        this.showError = false
        try {
          let response = await axios.post("https://todo-api.spico.tech/api/auth/sign_up", this.signUpParams)
          localStorage.currentUser = JSON.stringify(response.data)
          this.$router.push({name: 'Home'})
        } catch (err) {
          this.errors = err.response.data.errors
          this.showError = true
        }
      },
      async checkUserLoggedIn(){
        if(localStorage.getItem('currentUser')!==undefined){
          try {
            let response = await axios.get("https://todo-api.spico.tech/api/auth/validate_token", {headers: {Authorization: JSON.parse(localStorage.getItem('currentUser')).Authorization}})
            localStorage.currentUser = JSON.stringify(response.data)
            this.$router.push({name: 'Home'})
          } catch (err) {}
        }
      }
    },
    mounted() {
      this.checkUserLoggedIn()
    }
  }
</script>